--- Projects/fltk-1.3/src/Fl_Tabs.cxx	2016-09-26 05:22:10.015968982 -0400
+++ Fl_Tabs.cxx	2016-09-26 05:21:36.701882909 -0400
@@ -53,7 +53,7 @@
   if (nc == 0) return 0;
   int selected = 0;
   Fl_Widget*const* a = array();
-  int i;
+  int i = 0;
   char prev_draw_shortcut = fl_draw_shortcut;
   fl_draw_shortcut = 1;
 
@@ -69,26 +69,29 @@
     tab_pos[i+1] = tab_pos[i] + tab_width[i] + BORDER;
   }
   fl_draw_shortcut = prev_draw_shortcut;
-
-  int r = w();
-  if (tab_pos[i] <= r) return selected;
-  // uh oh, they are too big:
-  // pack them against right edge:
-  tab_pos[i] = r;
-  for (i = nc; i--;) {
-    int l = r-tab_width[i];
-    if (tab_pos[i+1] < l) l = tab_pos[i+1];
-    if (tab_pos[i] <= l) break;
-    tab_pos[i] = l;
-    r -= EXTRASPACE;
-  }
-  // pack them against left edge and truncate width if they still don't fit:
-  for (i = 0; i<nc; i++) {
-    if (tab_pos[i] >= i*EXTRASPACE) break;
-    tab_pos[i] = i*EXTRASPACE;
-    int W = w()-1-EXTRASPACE*(nc-i) - tab_pos[i];
-    if (tab_width[i] > W) tab_width[i] = W;
-  }
+  // Make tabs compress to fill the tab bar when space is limited.
+  // This function is accurate within one pixel.
+  long double r = (long double)(w()-tab_width[selected])/(long double)(nc-1);
+  long double uptick = r - (long)r;
+  long double count = 0;
+  r = (long)r;
+/*  if(r > 0 && r/(double)w() < 0.02) {
+    tab_state |= 1 << FL_TABS_NOCLOSE;
+  } else {
+    tab_state &= ~(1 << FL_TABS_NOCLOSE);
+  }*/
+  if (tab_pos[i] > w()) {
+    for (i=0;i < nc; i++) {
+      if (selected != i)
+        tab_width[i] = r + (count>=1?1:0) - BORDER;
+      tab_pos[i+1] = tab_pos[i] + tab_width[i] + BORDER;
+      if (count >= 1) count = count - (long)count;
+      count = count+uptick;
+    }
+    //Backtrack and fill the rest of the tab bar.
+    tab_width[nc-1] = w() - tab_pos[nc-1];
+    tab_pos[nc] = tab_pos[nc-1] + tab_width[nc-1] + BORDER;
+  } 
   // adjust edges according to visiblity:
   for (i = nc; i > selected; i--) {
     tab_pos[i] = tab_pos[i-1] + tab_width[i-1];
@@ -336,8 +339,8 @@
 
   if (damage() & FL_DAMAGE_ALL) { // redraw the entire thing:
     Fl_Color c = v ? v->color() : color();
-
-    draw_box(box(), x(), y()+(H>=0?H:0), w(), h()-(H>=0?H:-H), c);
+    if (!children()) draw_box(box(), x(), y(), w(), h(), c);
+    else draw_box(box(), x(), y()+(H>=0?H:0), w(), h()-(H>=0?H:-H), c);
 
     if (selection_color() != c) {
       // Draw the top or bottom SELECTION_BORDER lines of the tab pane in the
@@ -356,6 +359,9 @@
     int selected = tab_positions();
     int i;
     Fl_Widget*const* a = array();
+    if(nc)
+      draw_box(box() , x(), y() + (H>=0?0:h()+H), w(),
+               (H>=0?H:-H), color());
     for (i=0; i<selected; i++)
       draw_tab(x()+tab_pos[i], x()+tab_pos[i+1],
                tab_width[i], H, a[i], LEFT);
@@ -375,6 +381,7 @@
   int dh = Fl::box_dh(box());
   int dy = Fl::box_dy(box());
   char prev_draw_shortcut = fl_draw_shortcut;
+  Fl_Align align = FL_ALIGN_CENTER;
   fl_draw_shortcut = 1;
 
   Fl_Boxtype bt = (o==push_ &&!sel) ? fl_down(box()) : box();
@@ -383,7 +390,8 @@
   int yofs = sel ? 0 : BORDER;
 
   if ((x2 < x1+W) && what == RIGHT) x1 = x2 - W;
-
+  // Left align tab text if space gets tight, this should be adjustable.
+  if (W < w() * 0.07) align = FL_ALIGN_LEFT;
   if (H >= 0) {
     if (sel) fl_push_clip(x1, y(), x2 - x1, H + dh - dy);
     else fl_push_clip(x1, y(), x2 - x1, H);
@@ -399,7 +407,7 @@
 
     // Draw the label using the current color...
     o->labelcolor(sel ? labelcolor() : o->labelcolor());
-    o->draw_label(x1, y() + yofs, W, H - yofs, FL_ALIGN_CENTER);
+    o->draw_label(x1, y() + yofs, W, H - yofs, align);
 
     // Restore the original label color...
     o->labelcolor(oc);
@@ -425,7 +433,7 @@
 
     // Draw the label using the current color...
     o->labelcolor(sel ? labelcolor() : o->labelcolor());
-    o->draw_label(x1, y() + h() - H, W, H - yofs, FL_ALIGN_CENTER);
+    o->draw_label(x1, y() + h() - H, W, H - yofs, align);
 
     // Restore the original label color...
     o->labelcolor(oc);
